BuildRequires: /proc
BuildRequires: jpackage-1.5-compat
# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with_tests %{!?_without_tests:1}%{?_without_tests:0}
%define without_tests %{?_without_tests:1}%{!?_without_tests:0}

%define gcj_support 0

%define bootstrap %{?_with_bootstrap:1}%{!?_with_bootstrap:%{?_without_bootstrap:0}%{!?_without_bootstrap:%{?_bootstrap:%{_bootstrap}}%{!?_bootstrap:0}}}


Name:           mx4j
Version:        3.0.1
Release:        alt5_8.M40.jpp5
Epoch:          0
Summary:        Open source implementation of JMX Java API
License:        Apache License
Group:          Development/Java
Source0:        %{name}-%{version}-src.tar.gz
Source1:        %{name}-build.policy
Source2:        CatalogManager.properties
Patch0:         mx4j-javaxssl.patch
Patch1:         mx4j-%{version}.patch
Patch2:         mx4j-build.patch
Patch3:         mx4j-docbook.patch
Patch4:         mx4j-no-poa.patch
Patch5:         mx4j-caucho-build.patch
Patch6:         mx4j-no-iiop.patch
Patch7:         mx4j-split-tools.patch
Patch33: mx4j-3.0.1-alt-local-xsl-stylesheets.patch
Url:            http://mx4j.sourceforge.net/
BuildRequires: jpackage-utils > 0:1.6
BuildRequires: ant >= 0:1.6
BuildRequires: ant-trax
%if ! %{bootstrap}
BuildRequires: ant-apache-resolver
BuildRequires: jaf
BuildRequires: javamail
BuildRequires: xjavadoc
BuildRequires: xdoclet
BuildRequires: wsdl4j
BuildRequires: jakarta-commons-discovery
%endif
BuildRequires: bcel >= 0:5.0
BuildRequires: log4j >= 0:1.2.7
BuildRequires: jakarta-commons-logging >= 0:1.0.1
BuildRequires: jetty5
BuildRequires: xml-commons-apis
BuildRequires: coreutils
BuildRequires: docbook-dtds >= 0:1.0
BuildRequires: docbook-style-xsl >= 0:1.61
BuildRequires: xml-commons-resolver
BuildRequires: xml-commons
BuildRequires: xerces-j2
%if %{with_tests}
BuildRequires: ant-junit
BuildRequires: junit >= 0:3.7.1
BuildRequires: xmlunit
%endif
%if ! %{gcj_support}
Buildarch:      noarch
BuildRequires: gnu-crypto
%endif
Requires(post): alternatives >= 0:0.2.0-alt0.12
Requires(postun): alternatives >= 0:0.2.0-alt0.12
%if ! %{bootstrap}
Requires: jaf
Requires: javamail
%endif
Requires: log4j >= 0:1.2.7
Requires: jakarta-commons-logging >= 0:1.0.1
Requires: xml-commons-apis
Requires: bcel >= 0:5.0
Requires: xml-commons-resolver
Requires: xml-commons
Obsoletes:      openjmx
Provides:       jmxri

%if %{gcj_support}
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%description
OpenJMX is an open source implementation of the
Java(TM) Management Extensions (JMX).

%if ! %{bootstrap}
%package tools-extra
Group:          Development/Java
Summary:        Additional protocols and scripting for %{name}
BuildRequires: jython >= 2.1
BuildRequires: axis >= 0:1.1
BuildRequires: burlap >= 3.0.8
BuildRequires: caucho-services
BuildRequires: hessian >= 3.0.8
Requires: jython >= 2.1
Requires: axis >= 0:1.1
Requires: burlap >= 3.0.8
Requires: caucho-services
Requires: hessian >= 3.0.8

%description    tools-extra
%{summary}.
%endif

%if ! %{bootstrap}
%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}
Obsoletes:      openjmx-javadoc

%description javadoc
%{summary}.
%endif

%if ! %{bootstrap}
%package manual
Group:          Development/Documentation
Summary:        Documentation for %{name}

%description    manual
%{summary}.
%endif

%prep
%setup -q

# FIXME To enable iiop when rmic becomes available for GCJ
# turn off patch6 and turn on patch4
# Patch4 is a backport of upstream changes (MX4J) and may go
# away on future releases
%patch0 -p1 -b .sav0
%patch1 -p0 -b .sav1
%patch2 -b .sav2
%patch3 -p1 -b .sav3
%if ! %{gcj_support}
%patch4 -p0 -b .sav4
%else
%patch5 -p1 -b .sav5
%patch6 -p1 -b .sav6
%endif
%patch7 -p0
%patch33 -p1

cp %{SOURCE1} build
cp %{_sourcedir}/CatalogManager.properties %{_builddir}/%{name}-%{version}/build/

pushd lib
%if %{with_tests}
   ln -sf $(build-classpath junit) .
   ln -sf $(build-classpath xmlunit) .
%endif
   ln -sf $(build-classpath xml-commons-apis) xml-apis.jar
   ln -sf $(build-classpath xerces-j2) xercesImpl.jar
   ln -sf $(build-classpath xalan-j2) xalan.jar
   ln -sf $(build-classpath commons-logging) .
   ln -sf $(build-classpath log4j) .
%if ! %{bootstrap}
   ln -sf $(build-classpath burlap) .
   ln -sf $(build-classpath caucho-services) .
   ln -sf $(build-classpath hessian) .
   ln -sf $(build-classpath axis/axis) .
   ln -sf $(build-classpath axis/jaxrpc) .
   ln -sf $(build-classpath axis/saaj) .
   ln -sf $(build-classpath wsdl4j) .
   ln -sf $(build-classpath jython) .
   ln -sf $(build-classpath xdoclet/xdoclet) .
   ln -sf $(build-classpath xdoclet/xdoclet-jmx-module) .
   ln -sf $(build-classpath xdoclet/xdoclet-mx4j-module) .
   ln -sf $(build-classpath javamail/mailapi) .
   ln -sf $(build-classpath javamail/smtp) .
   ln -sf $(build-classpath jaf) .
#
   ln -sf $(build-classpath commons-discovery) .
   ln -sf $(build-classpath jetty5/jetty5) org.mortbay.jetty.jar
%endif
   ln -sf $(build-classpath bcel) .
   ln -sf $(build-classpath servletapi5) servlet.jar
   ln -sf $(build-classpath jsse) .
   ln -sf $(build-classpath jsse/jcert) jcert.jar
   ln -sf $(build-classpath jsse/jnet) jnet.jar
   ln -sf $(build-classpath jaas) .
   ln -sf $(build-classpath xml-commons-resolver) .
popd

%build
export OPT_JAR_LIST="ant/ant-junit junit xmlunit ant/ant-trax jaxp_transform_impl ant/ant-apache-resolver xml-commons-resolver"

cd build
%if ! %{bootstrap}
%if %{with_tests}
ant -Dant.build.javac.source=1.4 -Dant.build.javac.target=1.4 -Dbuild.sysclasspath=first compile.jmx compile.rjmx compile.tools tests-report javadocs docs
%else
ant -Dant.build.javac.source=1.4 -Dant.build.javac.target=1.4 -Dbuild.sysclasspath=first compile.jmx compile.rjmx compile.tools javadocs docs
%endif
%else
ant -Dant.build.javac.source=1.4 -Dant.build.javac.target=1.4 -Dbuild.sysclasspath=first compile.jmx compile.rjmx
%endif

%install

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 dist/lib/%{name}-impl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-impl-%{version}.jar
install -m 644 dist/lib/%{name}-jmx.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-jmx-%{version}.jar
install -m 644 dist/lib/%{name}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-%{version}.jar
%if ! %{bootstrap}
install -m 644 dist/lib/%{name}-tools.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-tools-%{version}.jar
install -m 644 dist/lib/%{name}-tools-extra.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-tools-extra-%{version}.jar
%endif
install -m 644 dist/lib/%{name}-rjmx.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-rjmx-%{version}.jar
install -m 644 dist/lib/%{name}-rimpl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-rimpl-%{version}.jar
install -m 644 dist/lib/%{name}-remote.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-remote-%{version}.jar
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}/boa
install -m 644 dist/lib/boa/%{name}-rjmx-boa.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/boa/%{name}-rjmx-boa-%{version}.jar
install -m 644 dist/lib/boa/%{name}-rimpl-boa.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/boa/%{name}-rimpl-boa-%{version}.jar
install -m 644 dist/lib/boa/%{name}-remote-boa.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/boa/%{name}-remote-boa-%{version}.jar

pushd $RPM_BUILD_ROOT%{_javadir}/%{name}
   for jar in *-%{version}.jar ; do
      ln -fs ${jar} $(echo $jar | sed "s|-%{version}.jar|.jar|g")
   done
popd

%if ! %{bootstrap}
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -r dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%endif

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif
install -d $RPM_BUILD_ROOT/%_altdir; cat >$RPM_BUILD_ROOT/%_altdir/jmxri_%{name}<<EOF
%{_javadir}/jmxri.jar	%{_javadir}/%{name}/%{name}-jmx.jar	0
EOF

%pre
rm -f %{_javadir}/%{name}.jar

%post
%register_alternatives jmxri_%{name}

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
if [ "$1" = "0" ]; then
      %unregister_alternatives jmxri_%{name}
fi

%if ! %{bootstrap}
%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi
%endif

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%_altdir/jmxri_%{name}
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/%{name}-%{version}.jar
%{_javadir}/%{name}/%{name}.jar
%{_javadir}/%{name}/%{name}-impl-%{version}.jar
%{_javadir}/%{name}/%{name}-impl.jar
%{_javadir}/%{name}/%{name}-jmx-%{version}.jar
%{_javadir}/%{name}/%{name}-jmx.jar
%{_javadir}/%{name}/%{name}-remote-%{version}.jar
%{_javadir}/%{name}/%{name}-remote.jar
%{_javadir}/%{name}/%{name}-rimpl-%{version}.jar
%{_javadir}/%{name}/%{name}-rimpl.jar
%{_javadir}/%{name}/%{name}-rjmx-%{version}.jar
%{_javadir}/%{name}/%{name}-rjmx.jar
%if ! %{bootstrap}
%{_javadir}/%{name}/%{name}-tools-%{version}.jar
%{_javadir}/%{name}/%{name}-tools.jar
%endif
%dir %{_javadir}/%{name}/boa
%{_javadir}/%{name}/boa/*.jar

%if %{gcj_support}
%{_libdir}/gcj/%{name}/mx4j-%{version}.jar.*
%{_libdir}/gcj/%{name}/mx4j-tools-%{version}.jar.*
%{_libdir}/gcj/%{name}/mx4j-remote-boa-%{version}.jar.*
%endif

%if ! %{bootstrap}
%files tools-extra
%{_javadir}/%{name}/%{name}-tools-extra-%{version}.jar
%{_javadir}/%{name}/%{name}-tools-extra.jar
%if %{gcj_support}
%{_libdir}/gcj/%{name}/mx4j-tools-extra-3.0.1.jar.*
%endif
%endif

%if ! %{bootstrap}
%files javadoc
%{_javadocdir}/%{name}-%{version}
%endif

%if ! %{bootstrap}
%files manual
%doc dist/docs/*
%endif

%changelog
* Thu Aug 14 2008 Igor Vlasenko <viy@altlinux.ru> 0:3.0.1-alt5_8.M40.jpp5
- backport M40

* Thu Aug 14 2008 Igor Vlasenko <viy@altlinux.ru> 0:3.0.1-alt6_7jpp1.7
- fixed unpackaged dir

* Fri Mar 07 2008 Igor Vlasenko <viy@altlinux.ru> 0:3.0.1-alt5_7jpp1.7
- added mx4j-3.0.1-alt-local-xsl-stylesheets.patch

* Thu Nov 15 2007 Igor Vlasenko <viy@altlinux.ru> 0:3.0.1-alt4_7jpp1.7
- full-fledged build

* Tue Jul 31 2007 Igor Vlasenko <viy@altlinux.ru> 0:3.0.1-alt3_7jpp1.7
- updated to new jpackage release

* Fri Jun 08 2007 Igor Vlasenko <viy@altlinux.ru> 3.0.1-alt3
- provides jmxri; jpp compatible symlinks

* Wed Aug 10 2005 Mikhail Zabaluev <mhz@altlinux.ru> 3.0.1-alt2
- Added /proc to BuildRequires

* Sat Jul 30 2005 Mikhail Zabaluev <mhz@altlinux.ru> 3.0.1-alt1
- New upstream release

* Fri Feb 25 2005 Mikhail Zabaluev <mhz@altlinux.ru> 3.0.0-alt1
- New upstream release

* Thu Jan 20 2005 Mikhail Zabaluev <mhz@altlinux.ru> 2.1.1-alt1
- New upstream release

* Tue Nov 23 2004 Mikhail Zabaluev <mhz@altlinux.ru> 2.1.0-alt1
- New upstream release
- Package the all-in-one jars containing both API and implementation
- Provided jmx_impl alternative (thanks to Vladimir Lettiev for insight)

* Tue Jul 13 2004 Mikhail Zabaluev <mhz@altlinux.ru> 2.0.1-alt1
- New package for Sisyphus.
